--- app_record.c	2011-07-15 06:13:06.000000000 +1000
+++ app_record.c	2011-09-19 13:34:22.000000000 +1000
@@ -76,6 +76,9 @@
 					<option name="t">
 						<para>use alternate '*' terminator key (DTMF) instead of default '#'</para>
 					</option>
+					<option name="u">
+						<para>Ignore all terminator keys (DTMF) and keep recording until hangup.</para>
+					</option>
 					<option name="x">
 						<para>Ignore all terminator keys (DTMF) and keep recording until hangup.</para>
 					</option>
@@ -123,8 +126,9 @@
 	OPTION_STAR_TERMINATE = (1 << 4),
 	OPTION_IGNORE_TERMINATE = (1 << 5),
 	OPTION_KEEP = (1 << 6),
-	FLAG_HAS_PERCENT = (1 << 7),
-	OPTION_ANY_TERMINATE = (1 << 8),
+	OPTION_NO_TRUNCATE = (1 << 7),
+	FLAG_HAS_PERCENT = (1 << 8),
+	OPTION_ANY_TERMINATE = (1 << 9),
 };
 
 AST_APP_OPTIONS(app_opts,{
@@ -134,6 +138,7 @@
 	AST_APP_OPTION('q', OPTION_QUIET),
 	AST_APP_OPTION('s', OPTION_SKIP),
 	AST_APP_OPTION('t', OPTION_STAR_TERMINATE),
+	AST_APP_OPTION('u', OPTION_NO_TRUNCATE),
 	AST_APP_OPTION('y', OPTION_ANY_TERMINATE),
 	AST_APP_OPTION('x', OPTION_IGNORE_TERMINATE),
 });
@@ -157,6 +162,7 @@
 	int gotsilence = 0;		/* did we timeout for silence? */
 	int maxduration = 0;		/* max duration of recording in milliseconds */
 	int gottimeout = 0;		/* did we timeout for maxduration exceeded? */
+	int truncate = 1;		/* truncate on complete silence recording */
 	int terminator = '#';
 	int rfmt = 0;
 	int ioflags;
@@ -219,6 +225,9 @@
 	if (ast_test_flag(&flags, OPTION_IGNORE_TERMINATE))
 		terminator = '\0';
 
+	if (ast_test_flag(&flags, OPTION_NO_TRUNCATE))
+		truncate = 0;
+
 	/* done parsing */
 
 	/* these are to allow the use of the %d in the config file for a wild card of sort to
@@ -398,7 +407,7 @@
 		}
 	}
 
-	if (gotsilence) {
+	if (gotsilence && truncate) {
 		ast_stream_rewind(s, silence - 1000);
 		ast_truncstream(s);
 	} else if (!gottimeout) {
